/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package FunctionLayer;

import edu.mit.jmwe.data.IMWEDescID;
import edu.mit.jmwe.data.IRootMWEDesc;
import edu.mit.jmwe.index.IMWEIndex;
import edu.mit.jmwe.index.InMemoryMWEIndex;
import edu.stanford.nlp.pipeline.Annotation;
import edu.stanford.nlp.pipeline.JMWEAnnotator;
import edu.stanford.nlp.pipeline.StanfordCoreNLP;
import java.io.IOException;
import java.util.Map;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author install1
 */
//maybe not public?
public class PipelineJMWESingleton {

    public final static PipelineJMWESingleton INSTANCE = new PipelineJMWESingleton();
    private static Properties propsJMWE;
    private volatile static StanfordCoreNLP pipelineJMWE = initializeJMWE();
    //super important synchronization lock
    public synchronized final static Annotation getJMWEAnnotation(String str) {
        Annotation annoStr = new Annotation(str);
        pipelineJMWE.annotate(annoStr);
        return annoStr;
    }

    public final static StanfordCoreNLP initializeJMWE() {
        String jmweIndexData = "/home/javatests/lib/mweindex_wordnet3.0_semcor1.6.data"; // ./lib/mweindex_wordnet3.0_semcor1.6.data
        String jmweIndexDataLocalTest = "E:/java8/Projects/mweindex_wordnet3.0_semcor1.6.data";
        propsJMWE = new Properties();
        propsJMWE.setProperty("customAnnotatorClass.jmwe", "edu.stanford.nlp.pipeline.JMWEAnnotator");
        propsJMWE.setProperty("customAnnotatorClass.jmwe.verbose", "false");
        propsJMWE.setProperty("customAnnotatorClass.jmwe.underscoreReplacement", "-");
        propsJMWE.setProperty("customAnnotatorClass.jmwe.indexData", jmweIndexData); //jmweIndexDataLocalTest jmweIndexData
        propsJMWE.setProperty("customAnnotatorClass.jmwe.detector", "Exhaustive");
        //"Consecutive", "Exhaustive", "ProperNouns", "Complex" and "CompositeConsecutiveProperNouns"
        propsJMWE.setProperty("annotators", "tokenize, ssplit, pos, lemma, jmwe");
        System.out.println("finished singleton constructor \n");
        return new StanfordCoreNLP(propsJMWE);
    }

    private PipelineJMWESingleton() {
    }

    public final static PipelineJMWESingleton getINSTANCE() {
        return INSTANCE;
    }
}
